org.apache.commons.ssl

## Class Base64OutputStream

- java.lang.Object
- - java.io.OutputStream
  - - java.io.FilterOutputStream
    - - org.apache.commons.ssl.Base64OutputStream

All Implemented Interfaces:
  java.io.Closeable, java.io.Flushable, java.lang.AutoCloseable

    public class Base64OutputStream
    extends java.io.FilterOutputStream

Provides Base64 encoding and decoding in a streaming fashion (unlimited size). When encoding the default lineLength is 76 characters and the default lineEnding is CRLF, but these can be overridden by using the appropriate constructor.

The default behaviour of the Base64OutputStream is to ENCODE, whereas the default behaviour of the Base64InputStream is to DECODE. But this behaviour can be overridden by using a different constructor.

This class implements section 6.8. Base64 Content-Transfer-Encoding from RFC 2045 Multipurpose Internet Mail Extensions (MIME) Part One: Format of Internet Message Bodies by Freed and Borenstein.

Since this class operates directly on byte streams, and not character streams, it is hard-coded to only encode/decode character encodings which are compatible with the lower 127 ASCII chart (ISO-8859-1, Windows-1252, UTF-8, etc).

Since:
  1.4
Version:
  $Id$
Author:
  Apache Software Foundation
See Also:
  RFC 2045

### Field Summary

Fields
`private Base64` `base64`
`private boolean` `doEncode`
`private byte[]` `singleByte`

### Fields inherited from class java.io.FilterOutputStream

`out`

### Constructor Summary

Constructors
Constructor and Description
`Base64OutputStream(java.io.OutputStream out)` Creates a Base64OutputStream such that all data written is Base64-encoded to the original provided OutputStream.
`Base64OutputStream(java.io.OutputStream out, boolean doEncode)` Creates a Base64OutputStream such that all data written is either Base64-encoded or Base64-decoded to the original provided OutputStream.
`Base64OutputStream(java.io.OutputStream out, boolean doEncode, int lineLength, byte[] lineSeparator)` Creates a Base64OutputStream such that all data written is either Base64-encoded or Base64-decoded to the original provided OutputStream.

### Method Summary

Methods
`void` `close()` Closes this output stream and releases any system resources associated with the stream.
`void` `flush()` Flushes this output stream and forces any buffered output bytes to be written out to the stream.
`private void` `flush(boolean propogate)` Flushes this output stream and forces any buffered output bytes to be written out to the stream.
`void` `write(byte[] b, int offset, int len)` Writes `len` bytes from the specified `b` array starting at `offset` to this output stream.
`void` `write(int i)` Writes the specified `byte` to this output stream.

### Methods inherited from class java.io.FilterOutputStream

`write`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### doEncode

    private final boolean doEncode

#### base64

    private final Base64 base64

#### singleByte

    private final byte[] singleByte

### Constructor Detail

#### Base64OutputStream

    public Base64OutputStream(java.io.OutputStream out)

Creates a Base64OutputStream such that all data written is Base64-encoded to the original provided OutputStream.

Parameters:
  `out` - OutputStream to wrap.

#### Base64OutputStream

    public Base64OutputStream(java.io.OutputStream out,
                      boolean doEncode)

Creates a Base64OutputStream such that all data written is either Base64-encoded or Base64-decoded to the original provided OutputStream.

Parameters:
  `out` - OutputStream to wrap.
  `doEncode` - true if we should encode all data written to us, false if we should decode.

#### Base64OutputStream

    public Base64OutputStream(java.io.OutputStream out,
                      boolean doEncode,
                      int lineLength,
                      byte[] lineSeparator)

Creates a Base64OutputStream such that all data written is either Base64-encoded or Base64-decoded to the original provided OutputStream.

Parameters:
  `out` - OutputStream to wrap.
  `doEncode` - true if we should encode all data written to us, false if we should decode.
  `lineLength` - If doEncode is true, each line of encoded data will contain lineLength characters (rounded down to nearest multiple of 4). If lineLength <=0, the encoded data is not divided into lines. If doEncode is false, lineLength is ignored.
  `lineSeparator` - If doEncode is true, each line of encoded data will be terminated with this byte sequence (e.g. \r\n). If lineLength <= 0, the lineSeparator is not used. If doEncode is false lineSeparator is ignored.

### Method Detail

#### write

    public void write(int i)
               throws java.io.IOException

Writes the specified `byte` to this output stream.

Overrides:
  `write` in class `java.io.FilterOutputStream`
Parameters:
  `i` - source byte
Throws:
  `java.io.IOException` - if an I/O error occurs.

#### write

    public void write(byte[] b,
             int offset,
             int len)
               throws java.io.IOException

Writes `len` bytes from the specified `b` array starting at `offset` to this output stream.

Overrides:
  `write` in class `java.io.FilterOutputStream`
Parameters:
  `b` - source byte array
  `offset` - where to start reading the bytes
  `len` - maximum number of bytes to write
Throws:
  `java.io.IOException` - if an I/O error occurs.
  `java.lang.NullPointerException` - if the byte array parameter is null
  `java.lang.IndexOutOfBoundsException` - if offset, len or buffer size are invalid

#### flush

    private void flush(boolean propogate)
                throws java.io.IOException

Flushes this output stream and forces any buffered output bytes to be written out to the stream. If propogate is true, the wrapped stream will also be flushed.

Parameters:
  `propogate` - boolean flag to indicate whether the wrapped OutputStream should also be flushed.
Throws:
  `java.io.IOException` - if an I/O error occurs.

#### flush

    public void flush()
               throws java.io.IOException

Flushes this output stream and forces any buffered output bytes to be written out to the stream.

Specified by:
  `flush` in interface `java.io.Flushable`
Overrides:
  `flush` in class `java.io.FilterOutputStream`
Throws:
  `java.io.IOException` - if an I/O error occurs.

#### close

    public void close()
               throws java.io.IOException

Closes this output stream and releases any system resources associated with the stream.

Specified by:
  `close` in interface `java.io.Closeable`
Specified by:
  `close` in interface `java.lang.AutoCloseable`
Overrides:
  `close` in class `java.io.FilterOutputStream`
Throws:
  `java.io.IOException` - if an I/O error occurs.